Const adSaveCreateNotExist = 1
Const adSaveCreateOverWrite = 2
Const adTypeBinary = 1 'Binary data
Const adTypeText = 2 '(Default) Text data
Const adLF = 10
Const adCR = 13
Const adCRLF = -1

Const adReadLine = -2
Const adWriteChar = 0
Const adWriteLine = 1

Const SD_STAT = 0
Const SD_LSTART = 1
Const SD_LEND = 2
Const SD_TYPE = 3
Const SD_DECIMALS = 4
Const SD_P1 = 5
Const SD_P2 = 6
Const SD_P3 = 7
Const SD_P4 = 8
Const SD_P5 = 9
Const SD_P6 = 10
Const SDFLDCNT = 11

Const SDFLDSEP = ","
Const SDSTRQUOT = """"

Const InFileFull = "statdata.csv"
Const OutFileName = "CalcStat"
Const OutFileExtBas = ".bas"
Const OutFileExtLua = ".lua"

Const optOutFileBas = 1
Const optOutFileLua = 2

Const OutFileOption = 2

Const BST_KEY = 0
Const BST_VALUE = 1
Const BST_LEFT = 2
Const BST_RIGHT = 3
Const BSTFLDCNT = 4

Main
Sub Main

	Dim SDInfoLst

	ReadSDFile InFileFull,SDInfoLst
	
	If Not IsEmpty(SDInfoLst) Then
		MsgBox Replace("Found #N# data records.","#N#",CStr(UBound(SDInfoLst)+1))
	End If

	Dim OutStream
	Set OutStream = CreateObject("ADODB.Stream")
	With OutStream
		.Type = adTypeText
		.CharSet = "us-ascii"
		.LineSeparator = adCRLF
		.Open

		WriteScrStart OutStream

		Dim aStatsIndex
		aStatsIndex = CreateStatsIndex(SDInfoLst)
	
		Dim aBalancedBST
		aBalancedBST = CreateBalancedBST(aStatsIndex)
	
		Dim iNodeIndex
		iNodeIndex = 0

		WriteScrStatsNode OutStream, SDInfoLst, aBalancedBST, iNodeIndex, "	"

		WriteScrEnd OutStream

		Dim OutFileFull
If OutFileOption = optOutFileBas Then
		OutFileFull = OutFileName+OutFileExtBas
ElseIf OutFileOption = optOutFileLua Then
		OutFileFull = OutFileName+OutFileExtLua
End If
		.SaveToFile OutFileFull, adSaveCreateOverWrite
		.Close
	End With
	Set OutStream = Nothing

	MsgBox Replace(Replace("Compilation of #S1# to #S2# completed.","#S1#",InFileFull),"#S2#",OutFileFull)
	
End Sub

Sub WriteScrStart(theOutStream)

	With theOutStream

If OutFileOption = optOutFileBas Then
.WriteText "Function CalcStat(ByVal SName As String, ByVal SLvl As Double, Optional SParam As Variant) As Double", adWriteLine
.WriteText "", adWriteLine
.WriteText "	Dim SN As String", adWriteLine
.WriteText "	Dim HSN As String", adWriteLine
.WriteText "	Dim L As Double", adWriteLine
.WriteText "	Dim N As Double", adWriteLine
.WriteText "	Dim C As String", adWriteLine
.WriteText "", adWriteLine
.WriteText "	SN = UCase(LTrim(RTrim(SName)))", adWriteLine
.WriteText "	HSN = Left(SN,1)", adWriteLine
.WriteText "", adWriteLine
.WriteText "	L = SLvl", adWriteLine
.WriteText "", adWriteLine
.WriteText "	If IsMissing(SParam) Then", adWriteLine
.WriteText "		N = 1#", adWriteLine
.WriteText "		C = """"", adWriteLine
.WriteText "	ElseIf IsNumeric(SParam) Then", adWriteLine
.WriteText "		N = SParam", adWriteLine
.WriteText "		C = """"", adWriteLine
.WriteText "	Else", adWriteLine
.WriteText "		N = 1#", adWriteLine
.WriteText "		C = SParam", adWriteLine
.WriteText "	EndIf", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText "import (string.gsub(getfenv(1)._.Name,""%.CalcStat"","""").."".CalcSsup"");", adWriteLine
.WriteText "", adWriteLine
.WriteText "function CalcStat(sname, slvl, sparam)", adWriteLine
.WriteText "", adWriteLine
.WriteText "	local sn = string.upper(string.match(sname,""(%a+)""));", adWriteLine
.WriteText "	local hsn = string.sub(sn,1,1);", adWriteLine
.WriteText "", adWriteLine
.WriteText "	local L = slvl;", adWriteLine
.WriteText "	local N = 1;", adWriteLine
.WriteText "	local C = """";", adWriteLine
.WriteText "", adWriteLine
.WriteText "	if sparam ~= nil then", adWriteLine
.WriteText "		if type(sparam) == ""number"" then", adWriteLine
.WriteText "			N = sparam;", adWriteLine
.WriteText "		else", adWriteLine
.WriteText "			C = sparam;", adWriteLine
.WriteText "		end", adWriteLine
.WriteText "	end", adWriteLine
End If
.WriteText "", adWriteLine

	End With

End Sub

Sub WriteScrStatsNode(theOutStream,theSDInfoLst,aBST,iNodeIndex,sIndent)
	
	With theOutStream
		Dim sStatName
		sStatName = aBST(iNodeIndex)(BST_KEY)
		
		Dim iStatIndex
		iStatIndex = aBST(iNodeIndex)(BST_VALUE)
		
		Dim bIfOpen
		bIfOpen = False
		
		Dim iLeftIndex
		iLeftIndex = aBST(iNodeIndex)(BST_LEFT)
		
		If iLeftIndex <> -1 Then
			If bIfOpen Then
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"ElseIf SN < """+sStatName+""" Then", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"elseif sn < """+sStatName+""" then", adWriteLine
End If
			Else
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"If SN < """+sStatName+""" Then", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"if sn < """+sStatName+""" then", adWriteLine
End If
				bIfOpen = True
			End If
			WriteScrStatsNode theOutStream, theSDInfoLst, aBST, iLeftIndex, sIndent+"	"
		End If
		
		Dim iRightIndex
		iRightIndex = aBST(iNodeIndex)(BST_RIGHT)
		
		If iRightIndex <> -1 Then
			If bIfOpen Then
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"ElseIf SN > """+sStatName+""" Then", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"elseif sn > """+sStatName+""" then", adWriteLine
End If
			Else
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"If SN > """+sStatName+""" Then", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"if sn > """+sStatName+""" then", adWriteLine
End If
				bIfOpen = True
			End If
			WriteScrStatsNode theOutStream, theSDInfoLst, aBST, iRightIndex, sIndent+"	"
		End If

		If iLeftIndex = -1 Or iRightIndex = -1 Then
			If bIfOpen Then
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"ElseIf SN = """+sStatName+""" Then", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"elseif sn == """+sStatName+""" then", adWriteLine
End If
			Else
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"If SN = """+sStatName+""" Then", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"if sn == """+sStatName+""" then", adWriteLine
End If
				bIfOpen = True
			End If
			WriteScrStat theOutStream,sStatName,theSDInfoLst,sIndent+"	"
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"Else", adWriteLine
.WriteText sIndent+"	CalcStat = 0", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"else", adWriteLine
.WriteText sIndent+"	return 0;", adWriteLine
End If
		ElseIf iLeftIndex <> -1 And iRightIndex <> -1 Then
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"Else", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"else", adWriteLine
End If
			WriteScrStat theOutStream,sStatName,theSDInfoLst,sIndent+"	"
		End If

		If bIfOpen Then
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"End If", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"end", adWriteLine
End If
		End If
	End With

End Sub

Sub WriteScrEnd(theOutStream)

	With theOutStream

.WriteText "", adWriteLine
If OutFileOption = optOutFileBas Then
.WriteText "End Function", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText "end", adWriteLine
End If

	End With

End Sub

Function CreateStatsIndex(theSDInfoLst)

	Dim aStatsIndex

	Dim sStat, sLastStat
	sLastStat = ""

	For SI = LBound(theSDInfoLst) To UBound(theSDInfoLst)
		sStat = theSDInfoLst(SI)(SD_STAT)
		If sStat <> sLastStat Then
			If sLastStat <> "" Then
				Redim Preserve aStatsIndex(UBound(aStatsIndex)+1)
				aStatsIndex(UBound(aStatsIndex)) = Array(sStat,SI)
			Else
				aStatsIndex = Array(Array(sStat,SI))
			End If
			sLastStat = sStat
		End If
	Next

	MsgBox Replace("Number of stats: #N#","#N#",CStr(UBound(aStatsIndex)+1))

	CreateStatsIndex = aStatsIndex

End Function

Function CreateBalancedBST(aStatsIndex)

	Dim iLowIndex
	iLowIndex = LBound(aStatsIndex)
	
	Dim iHighIndex
	iHighIndex = UBound(aStatsIndex)

	Dim iStatIndex
	iStatIndex = Int((iLowIndex+(iHighIndex-iLowIndex)/2))

	Dim aBalancedBST
	aBalancedBST = Array(Array(-1,-1,-1,-1))
	
	Dim iNodeIndex
	iNodeIndex = UBound(aBalancedBST)

	aBalancedBST(iNodeIndex)(BST_KEY) = aStatsIndex(iStatIndex)(0)
	aBalancedBST(iNodeIndex)(BST_VALUE) = aStatsIndex(iStatIndex)(1)
	If iStatIndex-1 >= iLowIndex Then
		aBalancedBST(iNodeIndex)(BST_LEFT) = AddBSTnode(aBalancedBST,aStatsIndex,iLowIndex,iStatIndex-1)
	End If
	If iStatIndex+1 <= iHighIndex Then
		aBalancedBST(iNodeIndex)(BST_RIGHT) = AddBSTnode(aBalancedBST,aStatsIndex,iStatIndex+1,iHighIndex)
	End If

	CreateBalancedBST = aBalancedBST
	
	MsgBox Replace("Height of Binary Search Tree: #N#","#N#",GetHeightBSTnode(aBalancedBST,0))
		
End Function

Function AddBSTnode(ByRef aBST, ByRef aStatsIndex, ByVal iLowIndex, ByVal iHighIndex)

	Dim iStatIndex
	iStatIndex = Int((iLowIndex+(iHighIndex-iLowIndex)/2))
	
	Redim Preserve aBST(UBound(aBST)+1)
	aBST(UBound(aBST)) = Array(-1,-1,-1,-1)

	Dim iNodeIndex
	iNodeIndex = UBound(aBST)

	aBST(iNodeIndex)(BST_KEY) = aStatsIndex(iStatIndex)(0)
	aBST(iNodeIndex)(BST_VALUE) = aStatsIndex(iStatIndex)(1)
	If iStatIndex-1 >= iLowIndex Then
		aBST(iNodeIndex)(BST_LEFT) = AddBSTnode(aBST,aStatsIndex,iLowIndex,iStatIndex-1)
	End If
	If iStatIndex+1 <= iHighIndex Then
		aBST(iNodeIndex)(BST_RIGHT) = AddBSTnode(aBST,aStatsIndex,iStatIndex+1,iHighIndex)
	End If
	
	AddBSTnode = iNodeIndex
	
End Function

Function GetHeightBSTnode(ByRef aBST, ByVal iStatIndex)

	Dim iLeftIndex
	iLeftIndex = aBST(iStatIndex)(BST_LEFT)
	Dim iLeftHeight
	iLeftHeight = 0
	If iLeftIndex <> -1 Then
		iLeftHeight = GetHeightBSTnode(aBST,iLeftIndex)
	End If

	Dim iRightIndex
	iRightIndex = aBST(iStatIndex)(BST_RIGHT)
	Dim iRightHeight
	iRightHeight = 0
	If iRightIndex <> -1 Then
		iRightHeight = GetHeightBSTnode(aBST,iRightIndex)
	End If

	If iLeftHeight >= iRightHeight Then
		GetHeightBSTnode = iLeftHeight+1
	Else
		GetHeightBSTnode = iRightHeight+1
	End If
	
End Function

Sub WriteScrStat(theOutStream,theStat,theSDInfoLst,sIndent)

	With theOutStream

		Dim StatPos
		StatPos = -1
		
		For SI = LBound(theSDInfoLst) To UBound(theSDInfoLst)
			If theSDInfoLst(SI)(SD_STAT) = theStat Then
				StatPos = SI
				Exit For
			End If
		Next

		If StatPos >= 0 Then
			Dim Build

			For SI = StatPos To UBound(theSDInfoLst)
				If theSDInfoLst(SI)(SD_STAT) <> theStat Then
					Exit For
				End If

				If theSDInfoLst(SI)(SD_LEND) <> "" And SI = StatPos Then
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"Select Case L-DblCalcDev", adWriteLine
.WriteText sIndent+"	Case <= "+theSDInfoLst(SI)(SD_LEND)+"#", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"if L-DblCalcDev <= "+theSDInfoLst(SI)(SD_LEND)+" then", adWriteLine
End If
				ElseIf theSDInfoLst(SI)(SD_LEND) <> "" Then
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"	Case <= "+theSDInfoLst(SI)(SD_LEND)+"#", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"elseif L-DblCalcDev <= "+theSDInfoLst(SI)(SD_LEND)+" then", adWriteLine
End If
				ElseIf theSDInfoLst(SI)(SD_LSTART) <> "" Then
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"	Case Else", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"else", adWriteLine
End If
				End If

				Build = ""

				If theSDInfoLst(SI)(SD_TYPE) = "A" Then
					Build = Build+theSDInfoLst(SI)(SD_P1)
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "C" Then
					If InStr(theSDInfoLst(SI)(SD_P1),"/") Or InStr(theSDInfoLst(SI)(SD_P1),"+")  Or InStr(theSDInfoLst(SI)(SD_P1),"-") Then
						Build = Build+"("+theSDInfoLst(SI)(SD_P1)+")*N"
					ElseIf theSDInfoLst(SI)(SD_P1) = "1" Then
						Build = Build+"N"
					Else
						Build = Build+theSDInfoLst(SI)(SD_P1)+"*N"
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "F" Then
					Build = Build+theSDInfoLst(SI)(SD_P1)+"("
					If theSDInfoLst(SI)(SD_P2) <> "" Then
						Build = Build+theSDInfoLst(SI)(SD_P2)
					If theSDInfoLst(SI)(SD_P3) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P3)
					If theSDInfoLst(SI)(SD_P4) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P4)
					If theSDInfoLst(SI)(SD_P5) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P5)
					If theSDInfoLst(SI)(SD_P6) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P6)
					End If
					End If
					End If
					End If
					End If
					Build = Build+")*N"
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "E" Then
					If theSDInfoLst(SI)(SD_LSTART) <> "" Then
						Build = Build+"ExpFmod("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_LSTART)+","
					Else
						Build = Build+"ExpFmod("+theSDInfoLst(SI)(SD_P1)+",1,"
					End If
					Build = Build+theSDInfoLst(SI)(SD_P2)+","
					IF theSDInfoLst(SI)(SD_P3) <> "" Then
						Build = Build+"L+"+theSDInfoLst(SI)(SD_P3)+")*N"
					Else
						Build = Build+"L)*N"
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "L" Then
					If InStr(theSDInfoLst(SI)(SD_P1),"/") Or InStr(theSDInfoLst(SI)(SD_P1),"+")  Or InStr(theSDInfoLst(SI)(SD_P1),"-") Then
						Build = Build+"("+theSDInfoLst(SI)(SD_P1)+")*L"
					ElseIf theSDInfoLst(SI)(SD_P1) = "1" Then
						Build = Build+"L"
					Else
						Build = Build+theSDInfoLst(SI)(SD_P1)+"*L"
					End If
					If theSDInfoLst(SI)(SD_P2) <> "" Then
						Build = "("+Build+"+"+theSDInfoLst(SI)(SD_P2)+")*N"
					Else
						Build = Build+"*N"
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "N" Then
					If theSDInfoLst(SI)(SD_LSTART) <> "" And theSDInfoLst(SI)(SD_LSTART) <> "1" Then
						Build = Build+"NamedRangeValue("""+theSDInfoLst(SI)(SD_P1)+""",L-"+CStr(theSDInfoLst(SI)(SD_LSTART)-1)+","+theSDInfoLst(SI)(SD_P2)+")*N"
					Else
						Build = Build+"NamedRangeValue("""+theSDInfoLst(SI)(SD_P1)+""",L,"+theSDInfoLst(SI)(SD_P2)+")*N"
					End If
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "P" Then
					Build = Build+"CalcPercAB("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_P2)+","+theSDInfoLst(SI)(SD_P3)+",N)"
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "R" Then
					Build = Build+"CalcRatAB("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_P2)+","+theSDInfoLst(SI)(SD_P3)+",N)"
				ElseIf theSDInfoLst(SI)(SD_TYPE) = "T" Then
					Build = Build+"LinFmod("+theSDInfoLst(SI)(SD_P1)+","+theSDInfoLst(SI)(SD_P2)+","+theSDInfoLst(SI)(SD_P3)+","+theSDInfoLst(SI)(SD_P4)+","+theSDInfoLst(SI)(SD_P5)+",L"
					If theSDInfoLst(SI)(SD_P6) <> "" Then
						Build = Build+","+theSDInfoLst(SI)(SD_P6)+")*N"
					Else
						Build = Build+")*N"
					End If
				End If

				If theSDInfoLst(SI)(SD_DECIMALS) <> "" Then
					If theSDInfoLst(SI)(SD_DECIMALS) = "0" Then
						Build = "RoundDbl("+Build+")"
					Else
						Build = "RoundDbl("+Build+","+theSDInfoLst(SI)(SD_DECIMALS)+")"
					End If
				End If

				Build = Replace(Replace(Build,"!",""""),"|",",")

				Build = Replace(Build,"+-","-")

				Build = ReplStatRefs(Build)


				If theSDInfoLst(SI)(SD_LEND) <> "" Or theSDInfoLst(SI)(SD_LSTART) <> "" Then
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"		CalcStat = "+Build, adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"	return "+Build+";", adWriteLine
End If
				Else
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"CalcStat = "+Build, adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"return "+Build+";", adWriteLine
End If
				End If
			Next	

			If theSDInfoLst(StatPos)(SD_LSTART) <> "" Or theSDInfoLst(StatPos)(SD_LEND) <> "" Then
If OutFileOption = optOutFileBas Then
.WriteText sIndent+"End Select", adWriteLine
ElseIf OutFileOption = optOutFileLua Then
.WriteText sIndent+"end", adWriteLine
End If
			End If

		End If

	End With

End Sub

Function ReplStatRefs(ByVal theBuild)

	Dim Result
	Result = theBuild

	Dim nSearch
	Dim BI
	Dim sStartToken, sNumToken, sEncapStartToken, sEncapEndToken
	Dim nEncapOpen
	Dim sStatName
	Dim cStatChar
	Dim sLevel
	Dim sNumber

	sStartToken = "@"
	sNumToken = "#"
	sEncapStartToken = "{"
	sEncapEndToken = "}"

	nSearch = InStr(Result,sStartToken)
	While nSearch > 0
		Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sStartToken))

		sStatName = ""
		For BI = nSearch To Len(Result)
			cStatChar = Mid(Result,BI,1)
			If ("A" <= UCase(cStatChar) And UCase(cStatChar) <= "Z") Or (("0" <= UCase(cStatChar) And UCase(cStatChar) <= "9") And ("A" <= UCase(Mid(Result,BI+1,1)) And UCase(Mid(Result,BI+1,1)) <= "Z"))Then
				sStatName = sStatName+cStatChar
			Else
				Exit For	
			End If
		Next

		If Len(sStatName) > 0 Then
			Result = Left(Result,nSearch-1)+"CalcStat("""+sStatName+""""+Right(Result,Len(Result)-nSearch+1-Len(sStatName))
			nSearch = nSearch+Len("CalcStat("""+sStatName+"""")

			sLevel = ""
			If Mid(Result,nSearch,Len(sEncapStartToken)) = sEncapStartToken Then
				Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sEncapStartToken))
				nEncapOpen = 1
				For BI = nSearch To Len(Result)
					cStatChar = Mid(Result,BI,1)
					If Mid(Result,BI,Len(sEncapStartToken)) = sEncapStartToken Then
						nEncapOpen = nEncapOpen+1
					End If
					If Mid(Result,BI,Len(sEncapEndToken)) = sEncapEndToken Then
						nEncapOpen = nEncapOpen-1
					End If
					If nEncapOpen > 0 Then
						sLevel = sLevel+cStatChar
					Else
						Result = Left(Result,BI-1)+Right(Result,Len(Result)-BI+1-Len(sEncapEndToken))
						Exit For
					End If
				Next
			ElseIf "0" <= Mid(Result,nSearch,1) And Mid(Result,nSearch,1) <= "9" Then
				For BI = nSearch To Len(Result)
					cStatChar = Mid(Result,BI,1)
					If "0" <= cStatChar And cStatChar <= "9" Then
						sLevel = sLevel+cStatChar
					Else
						Exit For
					End If
				Next
			End If
			If sLevel = "" Then
				Result = Left(Result,nSearch-1)+",L"+Right(Result,Len(Result)-nSearch+1)
				nSearch = nSearch+Len(",L")
			Else
				Result = Left(Result,nSearch-1)+","+sLevel+Right(Result,Len(Result)-nSearch+1-Len(sLevel))
				nSearch = nSearch+Len(","+sLevel)
			End If

			If Mid(Result,nSearch,Len(sNumToken)) = sNumToken Then
				Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sNumToken))

				sNumber = ""
				If Mid(Result,nSearch,Len(sEncapStartToken)) = sEncapStartToken Then
					Result = Left(Result,nSearch-1)+Right(Result,Len(Result)-nSearch+1-Len(sEncapStartToken))
					nEncapOpen = 1
					For BI = nSearch To Len(Result)
						cStatChar = Mid(Result,BI,1)
						If Mid(Result,BI,Len(sEncapStartToken)) = sEncapStartToken Then
							nEncapOpen = nEncapOpen+1
						End If
						If Mid(Result,BI,Len(sEncapEndToken)) = sEncapEndToken Then
							nEncapOpen = nEncapOpen-1
						End If
						If nEncapOpen > 0 Then
							sNumber = sNumber+cStatChar
						Else
							Result = Left(Result,BI-1)+Right(Result,Len(Result)-BI+1-Len(sEncapEndToken))
							rem MsgBox "["+Result+"]"
							Exit For
						End If
					Next
				ElseIf "0" <= Mid(Result,nSearch,1) And Mid(Result,nSearch,1) <= "9" Then
					For BI = nSearch To Len(Result)
						cStatChar = Mid(Result,BI,1)
						If ("0" <= cStatChar And cStatChar <= "9") Or cStatChar = "." Then
							sNumber = sNumber+cStatChar
						Else
							Exit For
						End If
					Next
				End If
				If sNumber = "" Then
					Result = Left(Result,nSearch-1)+",N)"+Right(Result,Len(Result)-nSearch+1)
					nSearch = nSearch+Len(",N)")
				Else
					Result = Left(Result,nSearch-1)+","+sNumber+")"+Right(Result,Len(Result)-nSearch+1-Len(sNumber))
					nSearch = nSearch+Len(","+sNumber+")")
				End If
			Else
				Result = Left(Result,nSearch-1)+")"+Right(Result,Len(Result)-nSearch+1)
				nSearch = nSearch+Len(")")
			End If

		End If

		nSearch = InStr(Result,sStartToken)
	Wend

	ReplStatRefs = Result

End Function

Sub ReadSDFile(ByVal theInFile, ByRef theSDInfoLst)

	Dim InStream
	Set InStream = CreateObject("ADODB.Stream")
	With InStream
		.Type = adTypeText
		.CharSet = "UTF-8"
		.LineSeparator = adLF
		.Open
		.LoadFromFile theInFile

		Dim ReadError
		ReadError = False

		Dim RowText
		RowText = ""

		'skip header line
		RowText = .ReadText(adReadLine)

		Do Until .EOS OR ReadError
			RowText = .ReadText(adReadLine)

			RowText = Replace(RowText,Chr(10),"")
			RowText = Replace(RowText,Chr(13),"")

			Dim NewSDInfo
			InitSDInfo NewSDInfo

			For FldI = LBound(NewSDInfo) To UBound(NewSDInfo)
				ReadSDField RowText, NewSDInfo(FldI)
			Next

			If NewSDInfo(SD_STAT) = "" Then
				Break
			Else
				If IsEmpty(theSDInfoLst) Then
					ReDim theSDInfoLst(0)
				Else
					ReDim Preserve theSDInfoLst(UBound(theSDInfoLst)+1)
				End If
				theSDInfoLst(UBound(theSDInfoLst)) = NewSDInfo
			End If
		Loop

		.Close
	End With
	Set InStream = Nothing

End Sub

Sub InitSDInfo(ByRef theSDInfo)

	theSDInfo = Array("","","","","","","","","","","")
				
End Sub

Sub ReadSDField(ByRef RowText, ByRef NewSDFld)

	Dim SepPos
	SepPos = InStr(RowText,SDFLDSEP)
	If SepPos > 0 Then
		NewSDFld = RTrim(Mid(RowText,1,SepPos-1))
		RowText = LTrim(Mid(RowText,SepPos+1,Len(RowText)-SepPos))
	Else
		NewSDFld = Rtrim(RowText)
		RowText = ""
	End If

	If Len(NewSDFld) >= 2 Then
		If Mid(NewSDFld,1,1) = SDSTRQUOT AND Mid(NewSDFld,Len(NewSDFld),1) = SDSTRQUOT Then
			NewSDFld = Mid(NewSDFld,2,Len(NewSDFld)-2)
		End If
	End If

End Sub
